package com.isu.gaswellwatch.modbus.data.decode.impl;

import com.isu.gaswellwatch.modbus.data.ModbusMessage;
import com.isu.gaswellwatch.modbus.data.decode.DecodeHandler;
import jakarta.annotation.Resource;
import org.apache.commons.lang3.StringUtils;
import org.springframework.data.redis.core.HashOperations;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

/**
 * KNPCV1 柱塞器解析
 *
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2024/11/23 11:23
 */
@Component(Knpcv1DecodeHandler.MODBUS_DEVICE_TYPE)
public class Knpcv1DecodeHandler implements DecodeHandler {

    public static final String MODBUS_DEVICE_TYPE = "KNPCV1";

    @Resource
    private JdbcTemplate jdbcTemplate;

    @Resource(name = "redisTemplate")
    private RedisTemplate redisTemplate;

    @Override
    public void decode(ModbusMessage modbusMessage) {

        HashOperations<String, Object, Object> hashOperations = this.redisTemplate.opsForHash();
        String[] queuePath = StringUtils.split(modbusMessage.getQueueName(), "/");

        logger.info("Decode {}, Queue {}, Message {}", MODBUS_DEVICE_TYPE, modbusMessage.getQueueName(), modbusMessage.getMessage());

    }

}
