package com.isu.gaswellwatch.modbus.data.decode.listener;

import com.isu.gaswellwatch.utils.SpringUtil;
import org.springframework.amqp.core.BatchMessageListener;
import org.springframework.amqp.core.Message;

import java.util.ArrayList;
import java.util.List;

/**
 * @author <a href="mailto:shilong.wang@alpha-ess.com">王仕龙</a>
 * 2024/11/23 0:51
 */
public class ComposeModbusMessageListener implements BatchMessageListener {

    private final List<BatchMessageListener> messageListenerList = new ArrayList<>();

    public void addBatchMessageListener(BatchMessageListener listener) {
        SpringUtil.getApplicationContext().getAutowireCapableBeanFactory().autowireBean(listener);
        this.messageListenerList.add(listener);
    }

    @Override
    public void onMessage(Message message) {
        this.messageListenerList.forEach(messageListener -> messageListener.onMessage(message));
    }

    @Override
    public void onMessageBatch(List<Message> messages) {
        this.messageListenerList.forEach(messageListener -> messageListener.onMessageBatch(messages));
    }
}
